var AdblockPPLite = {
	init: function() {
		var prefBranch = Components.classes["@mozilla.org/preferences-service;1"]
							.getService(Components.interfaces.nsIPrefService)
							.getBranch("");
		var enable;
		try {
			enable = prefBranch.getBoolPref("extensions.adblock++_lite.enable");
		} catch(e) {
			prefBranch.setBoolPref("extensions.adblock++_lite.enable", true);
			enable = true;
		}
		var prefInternal = prefBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
		prefInternal.addObserver("extensions.adblock++_lite.enable", this, false);
		
		document.getElementById("adblockpplite-statusbar")
				.setAttribute("adblockpp", enable ? "true" : "false");
		
		var toolbarbutton = document.getElementById("adblockpplite-toolbarbutton");
		if (toolbarbutton) {
			toolbarbutton.checked = enable;
		}
	},
	
	finish: function() {
		var prefInternal = Components.classes["@mozilla.org/preferences-service;1"]
							.getService(Components.interfaces.nsIPrefService)
							.getBranch("")
							.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
		prefInternal.removeObserver("extensions.adblock++_lite.enable", this);
	},
	
	observe: function(aSubject, aTopic, aData) {
		if (aTopic == "nsPref:changed") {
			var prefBranch = aSubject.QueryInterface(Components.interfaces.nsIPrefBranch);
			var enable;
			try {
				enable = prefBranch.getBoolPref("extensions.adblock++_lite.enable");
			} catch(e) {
				prefBranch.setBoolPref("extensions.adblock++_lite.enable", true);
				enable = true;
			}
			document.getElementById("adblockpplite-statusbar")
					.setAttribute("adblockpp", enable ? "true" : "false");
					
			var toolbarbutton = document.getElementById("adblockpplite-toolbarbutton");
			if (toolbarbutton) {
				toolbarbutton.checked = enable;
			}
		}
	},
	
	onClick: function(aEvent) {
		if (aEvent.button == 0) {
			this.toggle();
		}
	},
	
	toggle: function(aElement) {
		var prefBranch = Components.classes["@mozilla.org/preferences-service;1"]
							.getService(Components.interfaces.nsIPrefService)
							.getBranch("");
		var prefString = aElement ? aElement.id : "extensions.adblock++_lite.enable";
		try {
			var enable = prefBranch.getBoolPref(prefString);
			prefBranch.setBoolPref(prefString, !enable);
		} catch(e) {}
	},
	
	openWindow: function(aChromeURLSpec, aWindowTitle) {
		var needToOpen = true;
		var wm = Cc["@mozilla.org/appshell/window-mediator;1"]
					.getService(Ci.nsIWindowMediator);
		var windows = wm.getEnumerator("");
		while (windows.hasMoreElements()) {
			var theEM = windows.getNext().QueryInterface(Ci.nsIDOMWindowInternal);
			if (theEM.document.documentElement.getAttribute("title") == aWindowTitle) {
				theEM.focus();
				needToOpen = false;
	 			break;
			}
		}
		if (needToOpen)
			window.openDialog(aChromeURLSpec, "", "chrome, all, dialog=no");
	},
	
	openEditor: function() {
		this.openWindow("chrome://adblock++/content/options.xul", "Adblock++ Lite Options");
	},
	
	popupInit: function() {
		var prefBranch = Components.classes["@mozilla.org/preferences-service;1"]
							.getService(Components.interfaces.nsIPrefService)
							.getBranch("");
		try {
			var enable = prefBranch.getBoolPref("extensions.adblock++_lite.enable");
		} catch(e) {
			prefBranch.setBoolPref("extensions.adblock++_lite.enable", true);
			enable = true;
		}
		try {
			var hideelement = prefBranch.getBoolPref("extensions.adblock++_lite.hide_element");
		} catch(e) {
			prefBranch.setBoolPref("extensions.adblock++_lite.hide_element", true);
			hideelement = true;
		}
		try {
			var checklink = prefBranch.getBoolPref("extensions.adblock++_lite.check_link");
		} catch(e) {
			prefBranch.setBoolPref("extensions.adblock++_lite.check_link", false);
			checklink = false;
		}
		try {
			var block = prefBranch.getBoolPref("extensions.adblock++_lite.block_1px_image");
		} catch(e) {
			prefBranch.setBoolPref("extensions.adblock++_lite.block_1px_image", false);
			block = false;
		}
		try {
			var popup = prefBranch.getBoolPref("extensions.adblock++_lite.popup_block");
		} catch(e) {
			prefBranch.setBoolPref("extensions.adblock++_lite.popup_block", false);
			popup = false;
		}
		/*
		try {
			var css = prefBranch.getBoolPref("extensions.adblock++_lite.css_filter");
		} catch(e) {
			prefBranch.setBoolPref("extensions.adblock++_lite.css_filter", true);
			css = true;
		}
		*/
		try {
			var console = prefBranch.getBoolPref("extensions.adblock++_lite.console_log");
		} catch(e) {
			prefBranch.setBoolPref("extensions.adblock++_lite.console_log", false);
			console = false;
		}
		document.getElementById("extensions.adblock++_lite.enable")
				.setAttribute("checked", enable ? "true" : "false");
		document.getElementById("extensions.adblock++_lite.hide_element")
				.setAttribute("checked", hideelement ? "true" : "false");
		document.getElementById("extensions.adblock++_lite.check_link")
				.setAttribute("checked", checklink ? "true" : "false");
		document.getElementById("extensions.adblock++_lite.block_1px_image")
				.setAttribute("checked", block ? "true" : "false");
		document.getElementById("extensions.adblock++_lite.popup_block")
				.setAttribute("checked", popup ? "true" : "false");
		/*
		document.getElementById("extensions.adblock++_lite.css_filter")
				.setAttribute("checked", css ? "true" : "false");
		*/
		document.getElementById("extensions.adblock++_lite.console_log")
				.setAttribute("checked", console ? "true" : "false");
	}
	
};

window.addEventListener("load", function() { AdblockPPLite.init(); }, false);
window.addEventListener("unload", function() { AdblockPPLite.finish(); }, false);
